<?php

/*
=====================================================
by Denik
=====================================================

*/


$plugin_info = array(
						'pi_name'			=> 'Send e-mail',
						'pi_version'		=> '1.02',
						'pi_author'			=> 'Denik',
						'pi_author_url'		=> 'http://denik.od.ua/',
						'pi_description'	=> 'Отправка писем',
						'pi_usage'			=> Send_email::usage()
					);


class Send_email {

    var $return_data;

    
    /** ----------------------------------------
    /**  Constructor
    /** ----------------------------------------*/

    function send_email($str = '')
    {
        global $TMPL, $PREFS, $REGX, $FNS, $LANG;
		

		if ( $TMPL->fetch_param('to') )
		{
			$to = $TMPL->fetch_param('to');
		}
		else return '';
		
		$title = ( $TMPL->fetch_param('title') ) ? $REGX->entities_to_ascii($TMPL->fetch_param('title')):"Информационное письмо";
		$title = $REGX->xss_clean(trim(stripslashes($title)));
		$attach = ( $TMPL->fetch_param('attach') ) ? $REGX->entities_to_ascii($TMPL->fetch_param('attach')):"";
		$attach_type = ( $TMPL->fetch_param('attach_type') ) ? $REGX->entities_to_ascii($TMPL->fetch_param('attach_type')):"";
		$return = ( $TMPL->fetch_param('return') ) ? $TMPL->fetch_param('return'):"";
		$mailtype = ( $TMPL->fetch_param('type') ) ? $TMPL->fetch_param('type'):"text"; // text|html
		$charset = ( $TMPL->fetch_param('charset') ) ? $TMPL->fetch_param('charset'):"utf-8";
		
		// if == /if
		$eq = $TMPL->fetch_param('eq_var_1');
		if( $eq!==FALSE )
		{
			for( $i=2; $i<=9; $i++ )
			if( $TMPL->fetch_param('eq_var_'.$i)!==FALSE )
			{
				if( $TMPL->fetch_param('eq_var_'.$i)!=$eq ) return '';
			}
		}
		
		if( $run_if = $TMPL->fetch_param('run_if') )
		{
			// run_if = " '123'=='321' || ('1'=='1' && '2'=='454545') "
			$run_if = $TMPL->advanced_conditionals(LD.'if '.$run_if.RD.'true'.LD.'if:else'.RD.'false'.LD.'/if'.RD);
			if( $run_if=='false' ) return;
		}
		
		if (stristr($title, LD.'if'))
		{
			$title = str_replace('&#47;', '/', $title);
			$title = $TMPL->segment_conditionals($title);
			$title = $TMPL->advanced_conditionals($title);
		}
		
		// Возвращаемый текст
		$this->return_data = $TMPL->tagdata;
		$errors = "";
		
		// Текст сообщения
		preg_match('/'.LD."message".'(.*?)'.RD.'(.*?)'.LD.SLASH."message".RD.'/s', $TMPL->tagdata, $message);
		if( !isset($message[2]) || trim($message[2]) == "" )
			return '';
		$this->return_data = str_replace($message[0], "", $this->return_data); // del tag "message"
		$message = $REGX->entities_to_ascii($message[2]);
		$message = str_replace('&#47;', '/', $message);
		if (stristr($message, LD.'if'))
		{
			$message = $TMPL->segment_conditionals($message);
			$message = $TMPL->advanced_conditionals($message);
		}

		// Перекодировать письмо ?
		if( $iconv = $TMPL->fetch_param('iconv') )
		{
			$title = iconv($charset, $iconv, $title);
			$message = iconv($charset, $iconv, $message);
			$charset = $iconv;
		}

		// Подключение класса отправки писем
		if ( ! class_exists('EEmail') )
		{
		    require PATH_CORE.'core.email'.EXT;
		}
		$email = new EEmail;

		// Attachments files to emails
		$exp_attach = explode("|", $attach );
		$attach_type = explode("|", $attach_type );
		if( count($exp_attach) > 0 )
		{
			foreach( $exp_attach as $i=>$attach )
			{
				$attach = trim($FNS->remove_double_slashes($attach));
				
				if ( $attach != "" && (file_exists( $attach ) || is_uploaded_file($attach)) )
				{
					//$email->attach( $attach );
					$attach_t = isset($attach_type[$i])?$attach_type[$i]:end(explode('.', basename($attach)));
					$email->attach_name[] = $attach;
					$email->attach_type[] = $email->mime_types($attach_t);
					$email->attach_disp[] = 'attachment'; // Can also be 'inline'  Not sure if it matters
				}
			}
		}
		
		// Sending emails
		$send_ok = "true";
		$exp_to = explode("|", $to );
		foreach( $exp_to as $to )
		{
			$to = trim(str_replace("\n","",str_replace("\t","",strip_tags($to)))); 
			// Проверка e-mail на вшивость
			if ( ! preg_match("/^(.*?)@(.*?)\.(.*?)$/", $to) )
			{
				$errors .= "e-mail( $to ) - задан не в верном формате"."<br />";
				$send_ok = "false";
				$to = "";
			}
			if ( strlen($to) > 4 )
			{
				$from_mail = $TMPL->fetch_param('from_mail')?$TMPL->fetch_param('from_mail'):$PREFS->ini('webmaster_email');
				$from_name = $TMPL->fetch_param('from_name')?$TMPL->fetch_param('from_name'):$PREFS->ini('webmaster_name');
				
				$email->initialize();
				$email->charset = $charset;
				$email->wordwrap = true;
				$email->from($from_mail, $from_name);
				$email->to($to);
				$email->subject($title);
				$email->mailtype = $mailtype;
				$email->message($message);

				if ( ! $email->Send() )
				{
					$errors .= $LANG->line('error_sending_email')."<br />";
					$send_ok = "false";
				}
			}
		}
		
		// Обработка template
		$cfg = Array();
		
		// send_ok
		$this->return_data = preg_replace('/'.LD."send_ok".RD.'/', $send_ok, $this->return_data);
		$cfg["send_ok"] = ( $send_ok=="true" ) ? true:false;
		
		// errors
		$this->return_data = preg_replace('/'.LD."errors".RD.'/', $errors, $this->return_data);
		
		$this->return_data = $FNS->prep_conditionals($this->return_data, $cfg);
		
		// Return ?
		if( $return != "" && !( $TMPL->fetch_param('no_return_on_error')=="true" && $send_ok != "true" ) )
		{
			$return = explode(",", $return);
			$time = ( isset($return[1]) ) ? $return[1]:0;
			$return = $FNS->create_url($return[0], 1);
			header("Refresh:$time; url=$return");
		}
    }
    /* END */

	
	/** ---------------------------------------
	/**  Plugin Usage
	/** ---------------------------------------*/

	function usage()
	{
	ob_start(); 
	?>
	Пример использования:
	{exp:send_email to="mail_to@mail.com" title="Привет друг!" attach="/home/user/file1.rar"}
	
		{message}
			Тут текст письма.
		{/message}
		
		{if send_ok}
			Письмо отправлено успешно
		{if:else}
			Ошибки при отправке:
			{errors}
		{/if}
		
	{/exp:send_email}
	
	
	Параметры:
		-to - может принимать и несколько адресатов, разделенных символом "|"
		-title - содержит тему письма
		-from_mail - от кого (e-mail)
		-from_name - от кого (имя)
		-attach - содержит прикрепляемые файлы (также может принимать несколько значений, разеляемых символом "|"), если прикреплять файлы не надо - оставить пустым
		-return - Ссылка, по которой следует перейти после отправки письма (не обязательный параметр)
		--- примеры использования:
		----- return="index";
		----- return="index,5";  -  с задержкой в 5 сек.
		-no_return_on_error - true|false
		-type - тип форматирования text|html
		-charset - тип кодировки
		-iconv - перекодировать содержимое письма из кодировки charset в кодировку iconv
		-eq_var_1 - можно задавать параметром, переменные (eq_var_1, eq_var_2..., eq_var_9) - тогда письмо будет отправляться только если все эти параметры равны друг другу.
		-run_if = " '{segment_3}'=='my_title' && '{segment_4}'!='FAILD' " - настраиваемый режим запуска (как eq_var_N), письмо будет отправляться только если выполняются заданные условия
		
	Переменные:
		-send_ok - принимает true|false в зависиммости от успешности отправки
		-errors - описание ошибок
		
		
	!! Важно. Содержимое тега message, имеет высокий приоритет обработки, т.е. {screen_name} так и отправится как {screen_name}. Для его подстановки, заключайте весь плагин в тег {exp:member:custom_profile_data} или берите переменную из PHP. (так же и с другими переменными)

	<?php
	$buffer = ob_get_contents();
	
	ob_end_clean(); 

	return $buffer;
	}
	/* END */


}
// END CLASS
?>